#! /usr/bin/python

import os, sys, cgi
import string, re
import httplib, urllib, cgi


class HttpHeader :
    def __init__(self, type='text/html') :
        sys.stderr = sys.stdout # redirect errors to standard out
        print  """Content-type: %s

""" % type
        self.type = type
        

class OneNode :

    def __init__(self, name) :
	self.name = name
	self.inLinks = 0

    def inc(self) :
	self.inLinks = self.inLinks + 1

    def toString(self) :
	return '%d : %s' % (self.inLinks, self.name)


class TGPage :

    def __init__(self, siteName, serverName, path, wikiUrl) :
	self.siteName = siteName
        self.serverName = serverName
        self.server = httplib.HTTPConnection(self.serverName)
        self.path = path
	self.wikiUrl = wikiUrl

	self.mainDict = {}
	self.sortedList = []

        self.server.request('GET',self.path)
        self.response = self.server.getresponse()
        if self.response.status == 200 :
            self.page = self.response.read()
        else :
            print self.response.status, self.response.reason
        self.server.close()

    def processLine(self, line) :
	l = string.split(line,' ')
	fromPage = l[0]
	#print "\n** %s -==> " % fromPage
	l = l[1:]
	wordList = {}
	for w in l :
		if w[0:4] != 'http' and w[0:4] != 'mail' :
			if not wordList.has_key(w) : 
				wordList[w] = 1
				if not self.mainDict.has_key(w) :
					self.mainDict[w] = OneNode(w)
				self.mainDict[w].inc()


    def addToSortedList(self, node) :
	# position in list
	p = 0
	flag = 0
	if len(self.sortedList) == 0 :
		self.sortedList.append(node)
	else : 
		for x in self.sortedList :
			if node.inLinks > x.inLinks :
				self.sortedList.insert(p,node)
				# print "added %s at %d" % (node.toString(),p)
				flag = 1
				break
			p = p + 1
		if flag == 0 :
			self.sortedList.append(node)

    def processPage(self) :
	list = string.split(self.getPage(),'\n')
	for l in list :
		self.processLine(l)
		
	mdk = self.mainDict.keys()
	mdk.sort()
	for x in mdk :
		self.addToSortedList(self.mainDict[x])
		# print '%d : %s' % (self.mainDict[x].inLinks,x)


    def getPage(self) : 
        return self.page

    def textList(self) :
	s = ''
	for y in self.sortedList :
		s = s +  y.toString() + '\n'
	return s
	

    def htmlTable(self) :
	s = '<table>\n'
	for y in self.sortedList : 
		s = s + '<tr><td>%d</td><td><a href="%s%s">%s</a></td></tr>\n' % (y.inLinks, self.wikiUrl, y.name, y.name)
	s = s + '</table>'
	return s


class SmartForm :

    form = None # this is a class variable because you can only call cgi.FieldStorage once 
 
    def __init__(self) :
        sys.stderr = sys.stdout # redirect errors to standard out
        if SmartForm.form == None : # only do this once!
            SmartForm.form = cgi.FieldStorage() # gets data the came with the request into a form
        self.expectedFields = None


    def setExpectedFields(self, expectedFields) :
         """ Gets the expected fields out of self.field (the result of FieldStorage) and puts into attributes of this object"""
         self.expectedFields = expectedFields
         
         for fieldName in self.expectedFields : 
             if SmartForm.form.has_key(fieldName) : # if cgi form has it, 
                 v = SmartForm.form[fieldName].value
                 setattr(self,fieldName, v) # set own attribute value from cgi
             else :
                 if not hasattr(self, fieldName) : # otherwise, if it doesn't exist
                     setattr(self,fieldName,"") # set blank
                

    def __getitem__(self, item) :
        return getattr(self, item)

    def __setitem__(self, key, val) :
        setattr(self,key,val)


header = HttpHeader()
sf = SmartForm()
sf.setExpectedFields( ['siteName', 'domain', 'path', 'wikiUrl'] )

# defaults

if sf.siteName == '' :
	sf.siteName = 'ThoughtStorms'

if sf.domain == '' :
	sf.domain = 'www.nooranch.com'

if sf.path == '' :
	sf.path = '/synaesmedia/wiki/wiki.cgi?action=tgwb'

if sf.wikiUrl == '' :
	sf.wikiUrl = 'http://www.nooranch.com/synaesmedia/wiki/wiki.cgi?'


tgp = TGPage(sf.siteName,sf.domain,sf.path,sf.wikiUrl)


tgp.processPage()

print "<h2>%s</h2>" % tgp.siteName
print tgp.htmlTable()
